mod Ex02b

incl Mtex

incl Mauxb

loc rem 
  \para \bf  2. CVIČENIE Z PREDMETU 1-AIN-470 ŠPECIFIKÁCIA A VERIFIKÁCIA 
  PROGRAMOV  \end 

loc rem 
  \para* \it  Meno:  \end 
  \para* \it  Verzia CL:  \end 5.81.21 
  \para* \it  Dátum:  \end utorok 25.2.2020 
  \para* \it  WWW:  \end 
  http://www.ii.fmph.uniba.sk/cl/view.php/courses/1-AIN-470-svp/1920ls/?lang=sk 
  \para* \it  Kontakt:  \end Jan.Komara(at)fmph.uniba.sk 

loc rem 
  \para \bf  Úvodná poznámka.  \end Toto cvičenie je venované týmto 
  témam: 
  \items 
   \item \para celočíselná odmocnina (názorný príklad), 
   \item \para Cantorova párovacia funkcia a aritmetizácia karteziánskeho 
         súčinu, 
   \item \para Catalanova párovacia funkcia. 
  \end
  \para Zadanie sa skladá z týchto súborov: 
  \items 
   \item \para Súbory \it  mtex*.cl  \end obsahujú makrá pre CL-TeX. 
   \item \para Súbory \it  maux*.cl  \end obsahujú definície a vlastnosti 
         pomocných funkcií a predikátov. 
   \item \para Súbory \it  ex*.cl  \end obsahujú úlohy, ktoré máte riešiť 
         na tomto cvičení. 
   \item \para Súbor \it  msyntax.cl  \end obsahuje základnú syntax systému 
         CL. 
  \end
  \para Tieto súbory sa musia skompilovať v správnom poradí. Presný postup 
  je uvedený v súbore \it  readme.txt  \end. 

loc rem 
  \para \bf  Hodnotenie.  \end 
  \items 
   \item \para Počet bodov za úlohy v tomto súbore: 1
   \item \para Počet bodov za prémiove úlohy v tomto súbore: 0 
 \end
  \para Odovzdať do 2.3.2020 (pondelok) do 18:00. 

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end J. Komara. Specification and Verification of 
         Programs. Online. 
   \item \para \it  [2]  \end Ján Kľuka. Úvod do deklaratívneho 
         programovania. Online. 
  \end

rem 
  \para \bf  [CL] CL-TeX.  \end 

appldisp/1 Tex_f1_pp_triang
  Subsup(Id(0,'T',0),75,Arg(0),None)

appldisp/1 Tex_f1_pp_inv_triang
  Subsup(Id(0,'T',0),75,Arg(0),Prefix(90,0,Op(Ent('minus'),0),Num('1',0)))

appldisp/1 Tex_f1_pp_diag
  Std('d',0)

rem 
  \para \bf  Chapter. Beginning of Arithmetization.  \end 

rem 
  \para \bf  Section. Pairing Functions.  \end 

rem 
  \para \bf  Subsection. Cantor Pairing Function.  \end 

rem 
  \para \bf  Triangular numbers.  \end 
  \header* fun Triang 'Tex_f1_pp_triang' \end 
  \eq* 
    Tex_f1_pp_triang(n) = 1+2+3+Tex0_dotsc+(n-1)+n
  \end

fun Triang 'Tex_f1_pp_triang'
  Triang(n) = n*(n+1)/2

rem 
  \para \bf  The 'inverse' of the triangular function.  \end 
  \header* fun Inv_triang 'Tex_f1_pp_inv_triang' \end Define the unary function 
  \ft Inv_triang(m) \end such that 
  \eq* 
    Inv_triang(m) = n <-> Triang(n) <= m & m < Triang(n+1)
  \end
  \para \it  Hint.  \end Derivation is based on the following property of 
  triangular numbers 
  \eq* 
    8*Triang(n)+1 = Sq(2*n+1)
  \end

fun Inv_triang 'Tex_f1_pp_inv_triang'
  Inv_triang(m) = Foo

rem 
  \para \bf  Pairing function.  \end Define the modified Cantor pairing function 
  \ft Tex_f2_pp_pair(x,y) \end. 

fun/2 Pair 'Tex_f2_pp_pair'
  Pair(x,y) = Foo

rem 
  \para \bf  Basic properties of the pairing function.  \end We have 
  \eq* 
    Pair(x1,x2) = Pair(y1,y2) -> x1 = y1 & x2 = y2
  \end
  \eq* 
    x < Pair(x,y) & y < Pair(x,y)
  \end
  \eq* 
    x = 0 \/ \e y\e z x = Pair(y,z)
  \end

rem 
  \para \bf  Ordering properties of the pairing function.  \end We have 
  \eq* 
    Pair(x1,x2) <= Pair(y1,y2) <-> x1+x2 < y1+y2 \/ x1+x2 = y1+y2 & x1 <= y1
  \end
  \eq* 
    Pair(x1,x2) < Pair(y1,y2) <-> x1+x2 < y1+y2 \/ x1+x2 = y1+y2 & x1 < y1
  \end

rem 
  \para \bf  Diagonal function.  \end \header* fun Diag 'Tex_f1_pp_diag' \end 
  Define the unary function \ft Diag(x) \end such that 
  \eq* 
    Diag Pair(x,y) = x+y
  \end

fun Diag 'Tex_f1_pp_diag'
  Diag(x) = Foo

rem 
  \para \bf  Projections.  \end Define the projection functions of the pairing 
  function which are unary functions \ft Tex_f1_pp_proj1(x) \end and 
  \ft Tex_f1_pp_proj2(x) \end such that 
  \eq* 
    Tex_f1_pp_proj1(x) = y <-> x = 0 & y = 0 \/ \e z x = Pair(y,z)
  \end
  \eq* 
    Tex_f1_pp_proj2(x) = z <-> x = 0 & z = 0 \/ \e y x = Pair(y,z)
  \end

fun Proj1 'Tex_f1_pp_proj1'
  Proj1(x) = Foo

fun Proj2 'Tex_f1_pp_proj2'
  Proj2(x) = Foo

rem 
  \para \bf  Exercise.  \end Define the unary iteration 
  \ft Tex_f2_pp_iproj2(n,x) \end of the second projection function. 

fun/2 Iproj2 'Tex_f2_pp_iproj2'
  Iproj2(n,x) = Foo

rem 
  \para \bf  Exercise. \it  (1 point)  \end  \end Find a primitive recursive 
  definition of the following function 
  \eq* 
    Twofib(n) = Pair(Fib(n),Fib(n+1))
  \end
  \para which does not contain any application of \ft Fib(n) \end. 

fun Twofib 
  Twofib(n) = Foo

rem 
  \para \bf  Section. Tuples.  \end 

rem 
  \para \bf  Arithmetization of tuples.  \end \header* pred/2 Tuple  \end Define 
  the binary predicate \ft Tuple(n,x) \end holding if the number \ft x \end is 
  the code of an \ft n \end-tuple. Note that this includes the case when 
  \ft n = 0 \end or \ft n = 1 \end. Find an explicit definition of the 
  predicate! 

pred/2 Tuple 
  Tuple(n,x) <-> Poo

rem 
  \para \bf  Projection function for tuples.  \end Define the ternary function 
  \ft Tex_f3_pp_proj(n,x,i) \end which generalizes the projection functions 
  \ft Proj1(x) \end and \ft Proj2(x) \end to accept tuples, i.e. the application 
  \ft Tex_f3_pp_proj(n,x,i) \end yields the \ft i \end-th element of the 
  \ft n \end-tuple \ft x \end provided \ft 1 <= i & i <= n \end. 

fun/3 Proj 'Tex_f3_pp_proj'
  Proj(n,x,i) = Foo

