mod Ex02c

incl Mtex

loc rem 
  \para \bf  2. CVIČENIE Z PREDMETU 1-AIN-470 ŠPECIFIKÁCIA A VERIFIKÁCIA 
  PROGRAMOV  \end 

loc rem 
  \para* \it  Meno:  \end 
  \para* \it  Verzia CL:  \end 5.81.21 
  \para* \it  Dátum:  \end utorok 25.2.2020 
  \para* \it  WWW:  \end 
  http://www.ii.fmph.uniba.sk/cl/view.php/courses/1-AIN-470-svp/1920ls/?lang=sk 
  \para* \it  Kontakt:  \end Jan.Komara(at)fmph.uniba.sk 

loc rem 
  \para \bf  Úvodná poznámka.  \end Toto cvičenie je venované týmto 
  témam: 
  \items 
   \item \para celočíselná odmocnina (názorný príklad), 
   \item \para Cantorova párovacia funkcia a aritmetizácia karteziánskeho 
         súčinu, 
   \item \para Catalanova párovacia funkcia. 
  \end
  \para Zadanie sa skladá z týchto súborov: 
  \items 
   \item \para Súbory \it  mtex*.cl  \end obsahujú makrá pre CL-TeX. 
   \item \para Súbory \it  maux*.cl  \end obsahujú definície a vlastnosti 
         pomocných funkcií a predikátov. 
   \item \para Súbory \it  ex*.cl  \end obsahujú úlohy, ktoré máte riešiť 
         na tomto cvičení. 
   \item \para Súbor \it  msyntax.cl  \end obsahuje základnú syntax systému 
         CL. 
  \end
  \para Tieto súbory sa musia skompilovať v správnom poradí. Presný postup 
  je uvedený v súbore \it  readme.txt  \end. 

loc rem 
  \para \bf  Hodnotenie.  \end 
  \items 
   \item \para Počet bodov za úlohy v tomto súbore: 0
   \item \para Počet bodov za prémiove úlohy v tomto súbore: 0 
 \end
  \para Odovzdať do 2.3.2020 (pondelok) do 18:00. 

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end J. Komara. Specification and Verification of 
         Programs. Online. 
   \item \para \it  [2]  \end Ján Kľuka. Úvod do deklaratívneho 
         programovania. Online. 
  \end

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end J. Komara. Declarative Programming. Downloadable 
         lecture notes available through the web page of the course. 
   \item \para \it  [2]  \end J. Kľuka. Lecture Notes from Introduction to 
         Declarative Programming. 
   \item \para \it  [3]  \end J. Komara and P. J. Voda. Metamathematics of 
         Computer Programming. 2001. 
  \end

rem 
  \para \bf  Chapter. Beginning of Arithmetization.  \end 

rem 
  \para \bf  Section. Pairing Functions.  \end 

rem 
  \para \bf  Subsection. Catalan Pairing Function.  \end 

rem 
  \para \bf  [CL] Syntax.  \end The Catalan pairing function \ft x,y \end, 
  written as \ft 'x,y' \end, is pre-defined in CL. 

rem 
  \para \bf  Basic properties of Catalan pairing function.  \end We have 
  \eq* 
    x1,x2 = y1,y2 -> x1 = y1 & x2 = y2
  \end
  \eq* 
    x < x,y & y < x,y
  \end
  \eq* 
    x = 0 \/ \e y\e z x = y,z
  \end

rem 
  \para \bf  Ordering properties of Catalan pairing function.  \end We have 
  \eq* 
    x1,x2 < y1,y2 <-> 
    |x1,x2| < |y1,y2| \/ |x1,x2| = |y1,y2| & (x1 < y1 \/ x1 = y1 & x2 < y2)
  \end
  \para where \ft |x| \end is the pair size function defined in the module \it  
  Standard  \end. 

rem 
  \para \bf  [CL] Discrimination on pair patterns.  \end Example(s): 
  \def 
    fun F 'Tex_f1_f'
    F(0) = Foo
    F(v,w) = Foo
  \end
  \def 
    fun F 'Tex_f1_f'
    F(0) = Foo
    F(u,0) = Foo
    F(u,v,w) = Foo
  \end

rem 
  \para \bf  Subsubsection. Pair Representation of Numbers.  \end 

rem 
  \para \bf  Flattened trees.  \end 

pred Flattened 
  Flattened(0)
  Flattened(x,0) <- Flattened(x)

rem 
  \para \bf  Exercise.  \end Define the function \ft Flatten(x) \end such that 
  \eq* 
    |Flatten(x)| = |x|
  \end
  \eq* 
    Flattened Flatten(x)
  \end
  \para Do not use auxiliary functions! 

fun Flatten 
  Flatten(x) = Foo

